From a1415e664d17b56c7afeadba48b0b0d88d0eff56 Mon Sep 17 00:00:00 2001
From: Alexander Polakov <plhk@sdf.org>
Date: Thu, 20 Dec 2012 16:32:57 +0400
Subject: [PATCH 03/11] Handle _NET_ACTIVE_WINDOW ClientMessage

---
 xevents.c | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

diff --git a/xevents.c b/xevents.c
index 3d5a757..5a9ca3e 100644
--- a/xevents.c
+++ b/xevents.c
@@ -343,7 +343,7 @@ xev_handle_clientmessage(XEvent *ee)
 {
 	XClientMessageEvent	*e = &ee->xclient;
 	Atom			 xa_wm_change_state;
-	struct client_ctx	*cc;
+	struct client_ctx	*cc, *old_cc;
 
 	xa_wm_change_state = XInternAtom(X_Dpy, "WM_CHANGE_STATE", False);
 
@@ -356,6 +356,13 @@ xev_handle_clientmessage(XEvent *ee)
 
 	if (e->message_type == ewmh[_NET_CLOSE_WINDOW].atom && e->format == 32)
 		client_send_delete(cc);
+
+	if (e->message_type == ewmh[_NET_ACTIVE_WINDOW].atom && e->format == 32) {
+		old_cc = client_current();
+		if (old_cc)
+			client_ptrsave(old_cc);
+		client_ptrwarp(cc);
+	}
 }
 
 static void
-- 
1.8.1.2

